<template>
  <main v-if="machine" class="MachineView">
    <h2 class="MachineView__name">{{ machine.name }}</h2>
    <div class="MachineView__wrapper">
      <MachineOrder
        v-for="order of sortOrders(machine.orders, false)"
        :key="order.id"
        :order="order"
        @validity="(v) => (order.valid = v)"
      />
    </div>
    <h2>OF validés</h2>
    <div class="MachineView__wrapper">
      <MachineOrder
        v-for="order of sortOrders(machine.orders, true)"
        :key="order.id"
        :order="order"
        @validity="(v) => (order.valid = v)"
      />
    </div>
  </main>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import { workshop } from '@/states'
import MachineOrder from '@/views/partial/MachineOrder.vue'
import { useRouter } from 'vue-router'
import { Order } from '@/types'

export default defineComponent({
  name: 'Machine',
  components: { MachineOrder },

  props: {
    id: {
      type: String,
      required: true,
    },
  },

  setup(props) {
    const machine = workshop.machines[props.id]
    const router = useRouter()

    if (!machine) {
      console.log('Machine does not exist', { id: props.id })
      router.push('/')
      return {
        machine: null,
      }
    }
    return {
      machine,
      sortOrders: (orders: Order[], validity: boolean) =>
        orders
          .filter((o) => !!o.valid === validity)
          .sort((o1, o2) => {
            if (o1.schedule && o2.schedule)
              return o1.schedule.start.getTime() - o2.schedule.start.getTime()
            return -1
          }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../style/variables' as v;
@use '../style/view';

.MachineView {
  @extend .View;

  .MachineOrder {
    margin-bottom: v.$spacing;
    font-size: 150%;
  }
}
</style>
